#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>

double rdgen(double min, double max)
{

	int minInteger = (int)(min*10000);
    int maxInteger = (int)(max*10000);
    long randInteger = rand()*rand();
    int diffInteger = maxInteger - minInteger;
    int resultInteger = abs(randInteger%diffInteger) + minInteger;
	//printf("%f,%f,%f\n",resultInteger/10000.0,min,max);
    return resultInteger/10000.0;

}


double GaussianNoise(double mean,double variance)
{
	double Temp=0;
	double u1,u2;
	while(1)
	{
	u1=rdgen(0,1);
	u2=rdgen(0,1);
	Temp=sqrt(-2*(log(u1)))*sin(2*3.1415926*(u2));
	Temp=variance*Temp+mean;
	if(Temp>=1/3*mean && Temp<3*mean)
		break;
	}
	return Temp;
}

int main(int argc, char *argv[])
{
    FILE *fp,*fp1,*fp2,*fp3;
	char *temp, **fname;
	int i,j,k,ct,p,rd,n[20],miu[20],m[20],d[20],lq[20],l;
	int min,max,pre;
	int *rand,*newrd;
	int count,mk,count1;
	srand((unsigned)time(0));
	if((fp=fopen(argv[1],"r"))==NULL)
	{
		printf("cannot open file %s!\n",argv[1]);
		exit(0);
	}

	i=1;
	fname = (char **)malloc(sizeof(char *)*20);

	while(!feof(fp))
	{
		fname[i]=(char *)malloc(sizeof(char)*1024);
		fscanf(fp,"%s %d %d %d %d %d", fname[i], &(n[i]), &(miu[i]),&(lq[i]),&(d[i]),&(m[i]));
		printf("%s %d %d %d %d %d\n", fname[i], (n[i]), (miu[i]),(lq[i]),(d[i]),(m[i]));
		i++;
	}
	fclose(fp);


	ct=i;
	temp=(char *)malloc(sizeof(char)*1024);
	i=0;
	sprintf(temp,"rm -f -r data");
	system(temp);
	system("mkdir data");


	for(i=1;i<ct;i++)
	{
		//printf("%d,%d",ct,i);

		sprintf(temp,"mkdir data/%d",i);
		system(temp);
		sprintf(temp,"data/%d/data.txt",i);

		if((fp=fopen(temp,"w"))==NULL)
		{
			printf("cannot open file!\n");
			exit(0);
		}
		sprintf(temp,"data/%d/query.txt",i);
		if((fp1=fopen(temp,"w"))==NULL)
		{
			printf("cannot open file!\n");
			exit(0);
		}
		sprintf(temp,"data/%d/config",i);
		if((fp2=fopen(temp,"w"))==NULL)
		{
			printf("cannot open file!\n");
			exit(0);
		}
		fprintf(fp2,"%d",m[i]+2);
		fclose(fp2);
		sprintf(temp,"data/%d/sqlen.txt",i);
		if((fp3=fopen(temp,"w"))==NULL)
		{
			printf("cannot open file!\n");
			exit(0);
		}


		rand=(int *)malloc(sizeof(int)*n[i]);
		for(k=0;k<n[i];k++)
			rand[k]=0;

		min=0;
		max=n[i]-1;
		for(k=0;k<100;)
		{
			rd=(int)rdgen((double)min,(double)max);
			if(rand[rd]!=1)
			{
				rand[rd]=1;
				k++;
			}
		}

		count1=0;

		for(j=0;j<n[i];j++)
		{
			if(j%100000==0)
				printf("line %d--------------\n",j);
			l=0;
			while(l<2*lq[i])
				l=(int)GaussianNoise((double)miu[i],5);
			if(rand[j]==1)
			{
				fprintf(fp1,"%d ",lq[i]);
				count1++;
				newrd=(int *)malloc(sizeof(int)*l);
				for(k=0;k<l;k++)
					newrd[k]=0;
				for(k=0;k<lq[i];)
				{
					rd=(int)rdgen(1.0,(double)l)-1;
					if(newrd[rd]!=1)
					{
						newrd[rd]=1;
						k++;
					}
				}



			}
			count=0;
			fprintf(fp3,"%d\n",l);

			for(k=0;k<l;k++)
			{
				if(rand[j]==1 && newrd[k]==1)
				{

					mk=(int)rdgen(1.0,(double)m[i]);
					count++;
				}
				for(p=0;p<m[i];p++)
				{

					min=p*d[i]+1;
					max=(p+1)*d[i];

					rd=(int)rdgen((double)min,(double)max);
					if (p==m[i]-1 && k==l-1)
						fprintf(fp,"%d\n",rd);
					else
						fprintf(fp,"%d ",rd);


					if(rand[j]==1 && newrd[k]==1 && p==mk && count<lq[i])
					{
						fprintf(fp1,"%d ",rd);
					}
					else if(rand[j]==1 && newrd[k]==1 && p==mk && count==lq[i])
					{
						fprintf(fp1,"%d\n",rd);
					}

				}

			}




		}



		fclose(fp1);
		fclose(fp);
		fclose(fp3);
		printf("done!\n");

	}

	return 0;
}
